﻿using GrapeCity.Documents.Excel;
using System;
using System.IO;

namespace prj_GcExcel_ControlPageBreaks
{
    class Program
    {
        static Workbook workbook = new Workbook();
        static IWorksheet sheet;
        static void Main(string[] args)
        {
            Console.WriteLine("Control page breaks sample");

            NewWorkBook();
            sheet.FixedPageBreaks = false;
            //Add a horizontal page break before the start of new region
            sheet.HPageBreaks.Add(sheet.Range["A9"]);
            //Delete rows and columns before the page breaks, the page breaks will be adjusted.
            sheet.Range["4:5"].Delete();

            PrintManager printManager = new PrintManager();
            printManager.SavePDF("AdjustedPageBreaks_Deletion.pdf", workbook);

            NewWorkBook();
            //Set the page breaks as fixed, it will not be adjusted when deleting rows/columns.
            sheet.FixedPageBreaks = true;
            //Add a horizontal page break before the start of new region
            sheet.HPageBreaks.Add(sheet.Range["A9"]);
            //Delete rows and columns before the page breaks, the page breaks will not be adjusted.
            sheet.Range["4:5"].Delete();
            printManager.SavePDF("FixedPageBreaks_Deletion.pdf", workbook);

            //Insertion
            NewWorkBook();
            workbook.AutoParse = false;
            //Set the page breaks as fixed, it will not be adjusted when inserting rows/columns.
            sheet.FixedPageBreaks = false;
            //Add a horizontal page break before the start of new region
            sheet.HPageBreaks.Add(sheet.Range["A9"]);
            //Insert two rows before the page break
            sheet.Range["A3:G4"].EntireRow.Insert();
            object[,] data = new object[,]{
                {"4/1/18","East","Robert","Pen Set","80","$15.99","$1279.2"},
                {"9/18/18","East","Damon","Pencil","60","$4.99","$299.4"}
                };
            sheet.Range["A3:G4"].Value = data;
            printManager.SavePDF("AdjustedPageBreaks_Insertion.pdf", workbook);

            NewWorkBook();
            workbook.AutoParse = false;
            //Set the page breaks as fixed, it will not be adjusted when inserting rows/columns.
            sheet.FixedPageBreaks = true;
            //Add a horizontal page break before the start of new region
            sheet.HPageBreaks.Add(sheet.Range["A9"]);
            //Insert two rows before the page break
            sheet.Range["A3:G4"].EntireRow.Insert();
            sheet.Range["A3:G4"].Value = data;
            printManager.SavePDF("FixedPageBreaks_Insertion.pdf", workbook);

            Console.WriteLine("Press any key to exit");
            Console.ReadKey();
        }
        static void NewWorkBook()
        {
            workbook = new Workbook();
            workbook.Open(Path.Combine("Resources", "TestFile.xlsx"));
            sheet = workbook.Worksheets[0];
        }
      
    }
}
